using System;

namespace ConsoleApp1
{
    class Program
    {
        public static void A(int n, bool[,,] a, ref int min, int k, int t, bool s, int g)
        {
            int z = g;
            if (t != k)
            {
                for (int i = 0; i < 2; i++)
                {
                    for (int j = 0; j < n; j++)
                    {
                        if (a[t, j, i])
                        {
                            a[t, j, i] = false;
                            if ((s && (i == 0)) || (!s && (i == 1)))
                            {
                                z++;
                                if (s) s = false;
                                else s = true;
                                A(n, a, ref min, k, j, s, z);
                                if (s) s = false;
                                else s = true;
                            }
                            else A(n, a, ref min, k, j, s, z);
                            a[t, j, i] = true;
                        }
                        if (a[j, t, i])
                        {
                            a[j, t, i] = false;
                            if ((s && (i == 0)) || (!s && (i == 1)))
                            {
                                z++;
                                if (s) s = false;
                                else s = true;
                                A(n, a, ref min, k, j, s, z);
                                if (s) s = false;
                                else s = true;
                            }
                            else A(n, a, ref z, k, j, s, z);
                            a[j, t, i] = true;
                        }
                    }
                }
            }
            else
            {
                if (z < min) min = z;
                else if (min == -1) min = z;
            }
        }
        static void Main(string[] args)
        {
            string[] s = Console.ReadLine().Split();
            int n = int.Parse(s[0]);
            int m = int.Parse(s[1]);
            bool[,,] a = new bool[5000,5000,2];
            for (int i = 0; i < m; i++)
            {
                s = Console.ReadLine().Split();
                a[int.Parse(s[0]) - 1, int.Parse(s[1]) - 1, int.Parse(s[2])] = true;
            }
            s = Console.ReadLine().Split();
            int p = int.Parse(s[0]) - 1;
            int k = int.Parse(s[1]) - 1;
            int h = -1;
            A(n, a, ref h, k, p, false, 0);
            Console.WriteLine(h);
        }
    }
}